

#include <iostream>
#include <boost/thread.hpp>

class Reader
{
public:
  Reader() {}
  void start(Time_frame* time_frame)
  {
    thread = boost::thread(&Reader::read, this, time_frame);
  }
  void read(Time_frame* time_frame)
  {
    while(1)    
    {
      Time_frame::Interval_color color = time_frame->get_color();
      std::cout <<color<<" ";

      //sleep for 1 seconds
      boost::posix_time::seconds sleep_time(1);
      boost::this_thread::sleep(sleep_time);
    }
  }
  void join()
  {
    thread.join();
  }
private:
  boost::thread thread;
}; //Reader

class Writer
{
public:
  Writer() {}
  void start(Time_frame* time_frame)
  {
    thread = boost::thread(&Writer::write, this, time_frame);
  }
  void write(Time_frame* time_frame)
  {
    while(1)
    {
      boost::posix_time::seconds colored_sleep_time(4);
      boost::this_thread::sleep(colored_sleep_time);
      time_frame->change_color();
      
      boost::posix_time::seconds gray_sleep_time(1);
      boost::this_thread::sleep(gray_sleep_time);
      time_frame->change_color();
    }
    return;
  }
  void join()
  {
    thread.join();
  }
private:
  boost::thread thread;
}; //Writer

int main(int argc, char* argv[])
{
  Time_frame time_frame;
  Reader reader;
  reader.start(&time_frame);

  Writer writer;
  writer.write(&time_frame);

  Safe_type<int> safe_int(5);
  safe_int.set(3);


  reader.join();
  writer.join();
  return 0;
}

